#!/usr/bin/env node
"use strict";

var _meow = _interopRequireDefault(require("meow"));

var _ora = _interopRequireDefault(require("ora"));

var _chalk = _interopRequireDefault(require("chalk"));

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _nonIterableRest(); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/* eslint-disable max-len */
var cli = (0, _meow.default)("\n    ".concat(_chalk.default.dim.underline('Upload images:'), "\n      ").concat(_chalk.default.dim('$'), " ").concat(_chalk.default.green('imgur-upload'), " ").concat(_chalk.default.yellow('path/to/image.jpg'), "\n      ").concat(_chalk.default.dim('$'), " ").concat(_chalk.default.green('imgur-upload'), " ").concat(_chalk.default.yellow('path/to/image-one.jpg path/to/image-two.jpg'), "\n      ").concat(_chalk.default.dim('$'), " ").concat(_chalk.default.green('imgur-upload'), " ").concat(_chalk.default.yellow('path/to/*.jpg'), "\n\n    ").concat(_chalk.default.dim.underline('Upload latest image in a directory:'), "\n      ").concat(_chalk.default.dim('$'), " ").concat(_chalk.default.green('imgur-upload'), " ").concat(_chalk.default.blue('latest'), " ").concat(_chalk.default.yellow('path/to/directory'), "\n        ").concat(_chalk.default.dim('(if directory is not passed, defaults to the base directory)'), "\n\n    ").concat(_chalk.default.dim.underline('Get base directory:'), "\n      ").concat(_chalk.default.dim('$'), " ").concat(_chalk.default.green('imgur-upload'), " ").concat(_chalk.default.blue('basedir'), "\n\n    ").concat(_chalk.default.dim.underline('Set base directory:'), "\n      ").concat(_chalk.default.dim('$'), " ").concat(_chalk.default.green('imgur-upload'), " ").concat(_chalk.default.blue('basedir'), " ").concat(_chalk.default.yellow('path/to/base-directory'), "\n\n    ").concat(_chalk.default.dim.underline('View upload history:'), "\n      ").concat(_chalk.default.dim('$'), " ").concat(_chalk.default.green('imgur-upload'), " ").concat(_chalk.default.blue('history'), "\n\n    ").concat(_chalk.default.dim.underline('Clear upload history:'), "\n      ").concat(_chalk.default.dim('$'), " ").concat(_chalk.default.green('imgur-upload'), " ").concat(_chalk.default.blue('clear'), "\n"), {
  flags: {
    delete: {
      type: 'boolean',
      alias: 'd'
    }
  }
});
/* eslint-enable max-len */

var spinner = (0, _ora.default)(); // Map commands to api methods

var commands = {
  upload: function () {
    var _upload = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(imagePaths, flags) {
      var result, _result;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(imagePaths.length > 1)) {
                _context.next = 12;
                break;
              }

              spinner.text = _chalk.default.blue('Uploading images to an album');
              spinner.start();
              _context.next = 5;
              return _.default.uploadAlbum(imagePaths);

            case 5:
              result = _context.sent;
              spinner.stop();
              console.log(_chalk.default.dim('Album URL:'), _chalk.default.green("http://imgur.com/a/".concat(result.id)));
              console.log(_chalk.default.dim('Image URLs:'));
              imagePaths.forEach(function (imagePath, i) {
                console.log("  ".concat(_chalk.default.yellow(imagePath), " ").concat(_chalk.default.dim('=>'), " ").concat(_chalk.default.green(result.images[i].link)));
              });
              _context.next = 19;
              break;

            case 12:
              spinner.text = _chalk.default.blue("Uploading ".concat(imagePaths[0]));
              spinner.start();
              _context.next = 16;
              return _.default.uploadImage(imagePaths[0]);

            case 16:
              _result = _context.sent;
              spinner.stop();
              console.log(_chalk.default.green(_result.link));

            case 19:
              if (!flags.delete) {
                _context.next = 25;
                break;
              }

              spinner.text = _chalk.default.blue('Deleting input images');
              spinner.start();
              _context.next = 24;
              return _.default.deleteImages(imagePaths);

            case 24:
              spinner.stop();

            case 25:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function upload(_x, _x2) {
      return _upload.apply(this, arguments);
    }

    return upload;
  }(),
  basedir: function () {
    var _basedir = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(_ref) {
      var _ref2, dirPath, result;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _ref2 = _slicedToArray(_ref, 1), dirPath = _ref2[0];

              if (!dirPath) {
                _context2.next = 10;
                break;
              }

              spinner.text = _chalk.default.blue('Setting base directory');
              spinner.start();
              _context2.next = 6;
              return _.default.setBaseDirectory(dirPath);

            case 6:
              spinner.stop();
              console.log(_chalk.default.green('Base directory now set to'), _chalk.default.yellow(dirPath));
              _context2.next = 17;
              break;

            case 10:
              spinner.text = _chalk.default.blue('Getting base directory');
              spinner.start();
              _context2.next = 14;
              return _.default.getBaseDirectory();

            case 14:
              result = _context2.sent;
              spinner.stop();

              if (result) {
                console.log(_chalk.default.yellow(result));
              } else {
                console.log(_chalk.default.red('Base directory is currently not set.'));
              }

            case 17:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function basedir(_x3) {
      return _basedir.apply(this, arguments);
    }

    return basedir;
  }(),
  history: function () {
    var _history = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3() {
      var result;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              spinner.text = _chalk.default.blue('Getting upload history');
              spinner.start();
              _context3.next = 4;
              return _.default.getHistory();

            case 4:
              result = _context3.sent;
              spinner.stop();
              result.forEach(function (_ref3) {
                var deletehash = _ref3.deletehash,
                    link = _ref3.link;
                console.log("".concat(_chalk.default.yellow(deletehash)).concat(_chalk.default.dim(':'), " ").concat(_chalk.default.green(link)));
              });

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function history() {
      return _history.apply(this, arguments);
    }

    return history;
  }(),
  clear: function () {
    var _clear = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4() {
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              spinner.text = _chalk.default.blue('Clearing upload history');
              spinner.start();
              _context4.next = 4;
              return _.default.clearHistory();

            case 4:
              spinner.stop();
              console.log(_chalk.default.green('Upload history cleared.'));

            case 6:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function clear() {
      return _clear.apply(this, arguments);
    }

    return clear;
  }()
}; // Normalize commands and inputs

var _cli$input = _toArray(cli.input),
    command = _cli$input[0],
    inputs = _cli$input.slice(1);

if (!['basedir', 'history', 'clear'].includes(command)) {
  inputs = [command].concat(_toConsumableArray(inputs));
  command = 'upload';
} // Execute commands


_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee5() {
  return regeneratorRuntime.wrap(function _callee5$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          if (!(typeof commands[command] === 'function')) {
            _context5.next = 5;
            break;
          }

          _context5.next = 3;
          return commands[command](inputs, cli.flags);

        case 3:
          _context5.next = 6;
          break;

        case 5:
          console.log("Unknown command: ".concat(command));

        case 6:
        case "end":
          return _context5.stop();
      }
    }
  }, _callee5, this);
}))();