"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("@babel/polyfill");

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _util = _interopRequireDefault(require("util"));

var _trash = _interopRequireDefault(require("trash"));

var _config = _interopRequireDefault(require("./config"));

var _axios = _interopRequireDefault(require("./axios"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var readDir = _util.default.promisify(_fs.default.readdir);

var stat = _util.default.promisify(_fs.default.stat);

function uploadImage(_x) {
  return _uploadImage.apply(this, arguments);
}

function _uploadImage() {
  _uploadImage = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(imagePath) {
    var album,
        data,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            album = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : null;
            _context2.next = 3;
            return (0, _utils.base64File)(imagePath);

          case 3:
            _context2.t0 = _context2.sent;
            data = {
              image: _context2.t0
            };

            if (album) {
              data.album = album;
            }

            return _context2.abrupt("return", _axios.default.post(_config.default.API_IMAGE_URL, data).then(
            /*#__PURE__*/
            function () {
              var _ref = _asyncToGenerator(
              /*#__PURE__*/
              regeneratorRuntime.mark(function _callee(response) {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return addHistory(imagePath, response);

                      case 2:
                        return _context.abrupt("return", response);

                      case 3:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, this);
              }));

              return function (_x5) {
                return _ref.apply(this, arguments);
              };
            }()));

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _uploadImage.apply(this, arguments);
}

function uploadAlbum(_x2) {
  return _uploadAlbum.apply(this, arguments);
}

function _uploadAlbum() {
  _uploadAlbum = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3(imagePaths) {
    var album, albumID, images;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _axios.default.post(_config.default.API_ALBUM_URL);

          case 2:
            album = _context3.sent;
            albumID = album.deletehash;
            _context3.next = 6;
            return Promise.all(imagePaths.map(function (imagePath) {
              return uploadImage(imagePath, albumID);
            }));

          case 6:
            images = _context3.sent;
            return _context3.abrupt("return", _objectSpread({}, album, {
              images: images
            }));

          case 8:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));
  return _uploadAlbum.apply(this, arguments);
}

function deleteImages(imagePaths) {
  return (0, _trash.default)(imagePaths);
}

function getHistory() {
  return _utils.moduleConfig.get('history', []);
}

function addHistory(imagePath, data) {
  return _utils.moduleConfig.append('history', {
    id: data.id,
    path: imagePath,
    link: data.link,
    deletehash: data.deletehash
  });
}

function clearHistory() {
  return _utils.moduleConfig.set('history', []);
}

function setBaseDirectory(baseDirPath) {
  return _utils.moduleConfig.set('baseDir', baseDirPath);
}

function getBaseDirectory() {
  return _utils.moduleConfig.get('baseDir', null);
}

function getLatestImage(_x3) {
  return _getLatestImage.apply(this, arguments);
}

function _getLatestImage() {
  _getLatestImage = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee4(dirPath) {
    var files, images;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return readDir(dirPath);

          case 2:
            files = _context4.sent;
            images = files.filter(function (fileName) {
              return /\.(jpe?g|png|gif|bmp)$/.test(fileName);
            });
            return _context4.abrupt("return", images.reduce(function (latest, current) {
              var currentPath = _path.default.join(dirPath, current);

              var _Promise$all = Promise.all([stat(latest).then(function (s) {
                return new Date(s.mtime);
              }), stat(currentPath).then(function (s) {
                return new Date(s.mtime);
              })]),
                  _Promise$all2 = _slicedToArray(_Promise$all, 2),
                  latestTime = _Promise$all2[0],
                  currentTime = _Promise$all2[1];

              return latestTime > currentTime ? latest : currentPath;
            }, _path.default.join(dirPath, images[0])));

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));
  return _getLatestImage.apply(this, arguments);
}

function uploadLatestImage(_x4) {
  return _uploadLatestImage.apply(this, arguments);
}

function _uploadLatestImage() {
  _uploadLatestImage = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee5(dirPath) {
    var imagePath;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (dirPath) {
              _context5.next = 6;
              break;
            }

            _context5.next = 3;
            return getBaseDirectory();

          case 3:
            dirPath = _context5.sent;

            if (dirPath) {
              _context5.next = 6;
              break;
            }

            return _context5.abrupt("return", Promise.reject(new Error('Please provide a directory, or set the base directory.')));

          case 6:
            _context5.next = 8;
            return getLatestImage(dirPath);

          case 8:
            imagePath = _context5.sent;

            if (imagePath) {
              _context5.next = 11;
              break;
            }

            return _context5.abrupt("return", Promise.reject(new Error('No image found in the specified directory.')));

          case 11:
            return _context5.abrupt("return", uploadImage(imagePath));

          case 12:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));
  return _uploadLatestImage.apply(this, arguments);
}

var _default = {
  uploadImage: uploadImage,
  uploadAlbum: uploadAlbum,
  deleteImages: deleteImages,
  getHistory: getHistory,
  clearHistory: clearHistory,
  setBaseDirectory: setBaseDirectory,
  getBaseDirectory: getBaseDirectory,
  uploadLatestImage: uploadLatestImage
};
exports.default = _default;