"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.base64File = base64File;
exports.moduleConfig = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _util = _interopRequireDefault(require("util"));

var _userHome = _interopRequireDefault(require("user-home"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var readFile = _util.default.promisify(_fs.default.readFile);

var writeFile = _util.default.promisify(_fs.default.writeFile);

var ModuleConfig =
/*#__PURE__*/
function () {
  function ModuleConfig(fileName) {
    _classCallCheck(this, ModuleConfig);

    this.configPath = _path.default.join(_userHome.default, fileName);
  }

  _createClass(ModuleConfig, [{
    key: "_readConfig",
    value: function _readConfig() {
      return readFile(this.configPath).then(function (buffer) {
        return buffer.toString('ascii');
      }).then(function (contents) {
        return JSON.parse(contents);
      }).catch(function () {
        return {};
      });
    }
  }, {
    key: "_writeConfig",
    value: function _writeConfig(contents) {
      return writeFile(this.configPath, JSON.stringify(contents, null, '  '));
    }
  }, {
    key: "get",
    value: function () {
      var _get = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(key) {
        var defaultValue,
            contents,
            _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                defaultValue = _args.length > 1 && _args[1] !== undefined ? _args[1] : null;
                _context.next = 3;
                return this._readConfig();

              case 3:
                contents = _context.sent;
                return _context.abrupt("return", key in contents ? contents[key] : defaultValue);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function get(_x) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: "set",
    value: function () {
      var _set = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(key, value) {
        var contents;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._readConfig();

              case 2:
                contents = _context2.sent;
                contents[key] = value;
                return _context2.abrupt("return", this._writeConfig(contents));

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function set(_x2, _x3) {
        return _set.apply(this, arguments);
      }

      return set;
    }()
  }, {
    key: "append",
    value: function () {
      var _append = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(key) {
        var _contents$key;

        var contents,
            _len,
            values,
            _key,
            _args3 = arguments;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._readConfig();

              case 2:
                contents = _context3.sent;

                if (!(key in contents)) {
                  contents[key] = [];
                }

                for (_len = _args3.length, values = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                  values[_key - 1] = _args3[_key];
                }

                (_contents$key = contents[key]).push.apply(_contents$key, values);

                return _context3.abrupt("return", this._writeConfig(contents));

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function append(_x4) {
        return _append.apply(this, arguments);
      }

      return append;
    }()
  }]);

  return ModuleConfig;
}();

function base64File(filePath) {
  return readFile(filePath).then(function (buffer) {
    return buffer.toString('base64');
  });
}

var moduleConfig = new ModuleConfig('.imgur-upload');
exports.moduleConfig = moduleConfig;